package com.massa.mrules.droolsfight.beans;

/**
 * Error data.
 */
public class MeasureError {
	private String rule;
	private String msg;
	private boolean blocking;
	
	public MeasureError() {
	}
	
	public MeasureError(String rule, boolean blocking) {
		super();
		this.rule = rule;
		this.blocking = blocking;
	}
	
	public MeasureError(String rule, String msg, boolean blocking) {
		super();
		this.rule = rule;
		this.msg = msg;
		this.blocking = blocking;
	}
	
	public String toString() {
		return '[' + rule + " - " + (blocking ? "blocking " : "non blocking ") + '(' + msg + ')' + ']';
	}

	public String getRule() {
		return rule;
	}
	public void setRule(String rule) {
		this.rule = rule;
	}
	public String getMsg() {
		return msg;
	}
	public void setMsg(String msg) {
		this.msg = msg;
	}
	public boolean isBlocking() {
		return blocking;
	}
	public void setBlocking(boolean blocking) {
		this.blocking = blocking;
	}
	@Override
	public int hashCode() {
		return (blocking ? 1 : 3) * rule.hashCode() * msg.hashCode();
	}
	@Override
	public boolean equals(Object obj) {
		if (obj instanceof MeasureError) {
			return rule.equals(((MeasureError) obj).rule) && msg.equals(((MeasureError) obj).msg) && blocking == ((MeasureError) obj).blocking;
		}
		return false;
	}
	
	
}
