package com.massa.mrules.droolsfight.tests.java;

import java.util.regex.Pattern;

import com.massa.mrules.droolsfight.beans.MeasureBean;
import com.massa.mrules.droolsfight.beans.MeasureError;

public class RuleContactsOk implements IRule {

	private static final Pattern P = Pattern.compile(
			"^[_A-Za-z0-9-\\+]+(\\.[_A-Za-z0-9-]+)*@[A-Za-z0-9-]+(\\.[A-Za-z0-9]+)*(\\.[A-Za-z]{2,})$");

	@Override
	public void test(final MeasureBean data) {
		if (data.getMeasure().getContacts() == null || data.getMeasure().getContacts().isEmpty()) {
			data.addError(new MeasureError("ContactsOk", "Contacts are not present.", false));
		} else {
			for (final String contact: data.getMeasure().getContacts()) {
				if (! RuleContactsOk.P.matcher(contact).matches()) {
					data.addError(new MeasureError("ContactsOk", "Invalid contact.", false));
				}
			}
		}
	}
}
