package com.massa.mrules.droolsfight.tests.java;

import java.util.Arrays;
import java.util.HashSet;
import java.util.Set;

import com.massa.mrules.droolsfight.beans.MeasureBean;
import com.massa.mrules.droolsfight.beans.MeasureError;

public class RuleSamplesOk implements IRule {

	private static Set<String> SET = new HashSet<String>(Arrays.asList(new String[] {
			"M", "H", "D"}));

	@Override
	public void test(final MeasureBean data) {
		if (data.getMeasure().getNumberOfSamples() < 1 || data.getMeasure().getNumberOfSamples() > 10) {
			data.addError(new MeasureError("SamplesOk", "Incorrect number of samples.", true));
		}
		if (!RuleSamplesOk.SET.contains(data.getMeasure().getFrequency())) {
			data.addError(new MeasureError("SamplesOk", "Incorrect frequency value.", false));
		}
		if (data.getMeasure().getSampleData().size() < 1 || data.getMeasure().getSampleData().size() > 5) {
			data.addError(new MeasureError("SamplesOk", "Between 1 and 5 pollutants can be measured.", true));
		}
		if (!data.getPollutantTypes().containsAll(data.getMeasure().getSampleData().keySet())) {
			data.addError(new MeasureError("SamplesOk", "Incorrect pollutant type.", true));
		}
	}
}
